﻿

WAF.EntityCollection.manageData = function(rawResult, init)
{
	var priv = this;
	var entityCollection = this.owner;
	var dataClass = entityCollection.getDataClass();
	var cache = dataClass.getCache();
	init = init || false;
	
	if (init)
	{
		entityCollection.length = rawResult.__COUNT;
		priv.ready = true;
		priv.loadedElemsLength = entityCollection.length;
		priv.dataURI = rawResult.__ENTITYSET;
		if (priv.autoSubExpand != null)
		{
			priv.autoExpand = priv.autoSubExpand;
			priv.autoSubExpand = null;
		}
		
	}
	
	var nbEnts = rawResult.__SENT;
	var first = rawResult.__FIRST;
	cache.makeRoomFor(nbEnts);
	var arr = rawResult.__ENTITIES;
	var timeStamp = new Date();
	var page = new WAF.EntityCollectionPage(first, nbEnts);
	for (var i = 0; i < nbEnts; i++)
	{
		var rawEntity = arr[i];
		try {
		var stamp = cache.setEntry(rawEntity.__KEY, rawEntity, timeStamp);
		page.entityKeys.push({key:rawEntity.__KEY, stamp:stamp});
		} catch (e){
				//bug in wakanda!!!!!
		}
	}
	priv.insertPage(page);	
}





















function myParams1() {
		//this is what you need to provide
		var x = {};
		//template to be used in header
		x.templateHeaderRow =
                                    "<tr>" +
                                    "<td colspan='4' class='center'></td>" +
                                    "</tr>" +
									"<tr>" +
										"<td></td>" +
										"<td rowspan='2' class='center'></td>" +
										"<td colspan='2' class='center'></td>" +
									"</tr>" +
									"<tr>" +
										"<td></td>" +
										"<td></td>" +
                                        "<td></td>" +
									"</tr>";



		//template to be used in body
		x.templateBodyRow =
								"<tr>" +
									"<td></td>" +
                                    "<td rowspan='2'></td>" +
                                    "<td colspan='2'></td>" +
								"</tr>" +
								"<tr>" +
									"<td></td>" +
									"<td></td>" +
                                    "<td></td>" +
								"</tr>";

		//template to be used in body
		x.templateFooterRow =
								"<tr>" +
									"<td></td>" +
                                    "<td rowspan='2'></td>" +
									"<td></td>" +
                                    "<td></td>" +
								"</tr>" +
								"<tr>" +
									"<td></td>" +
									"<td></td>" +
                                    "<td></td>" +
								"</tr>";


		//attributes, make just as many as there are cells in template
		x.cellAttributesHeader =[
            {
                attributeName : "na",
                attributeHeader : "Freaky first, last and NA!!!!",
                width : 600
            },
            {
                attributeName : "firstName",
                attributeHeader : "First name",
                width : 150
			},
			{
                attributeName : "lastName",
                attributeHeader : "Last name again",
                width : 150
			},
			{
				attributeName : "na",
				attributeHeader : "na",
				width : 300
			},
			{
				attributeName : "lastName",
				attributeHeader : "Last name",
				width : 150
			},
			{
				attributeName : "na",
				attributeHeader : "na",
				width : 150
			},
			{
				attributeName : "na",
				attributeHeader : "na",
				width : 150
			},
            {
                attributeName : "na",
                attributeHeader : "na",
                width : 150
            },
            {
                attributeName : "na",
                attributeHeader : "na",
                width : 150
            }];

		//attributes, make just as many as there are cells in template
		x.cellAttributesBody = [
			{
				attributeName : "firstName",
				attributeHeader : "First name",
				width : 150
			},
			{
				attributeName : "lastName",
				attributeHeader : "Last name again",
				width : 150
			},
			{
				attributeName : "na",
				attributeHeader : "na",
				width : 150
			},
			{
				attributeName : "lastName",
				attributeHeader : "Last name",
				width : 150
			},
			{
				attributeName : "na",
				attributeHeader : "na",
				width : 150
			},
			{
				attributeName : "na",
				attributeHeader : "na",
				width : 150
			},
            {
                attributeName : "na",
                attributeHeader : "na",
                width : 150
            },
            {
                attributeName : "na",
                attributeHeader : "na",
                width : 150
            }];
		//attributes, make just as many as there are cells in template
		x.cellAttributesFooter = [
			{
				attributeName : "firstName",
				attributeHeader : "Footer1",
				width : 150
			},
			{
				attributeName : "lastName",
				attributeHeader : "Footer2",
				width : 150
			},
			{
				attributeName : "na",
				attributeHeader : "na",
				width : 150
			},
			{
				attributeName : "na",
				attributeHeader : "na",
				width : 150
			},
			{
				attributeName : "na",
				attributeHeader : "na",
				width : 150
			},
			{
				attributeName : "na",
				attributeHeader : "na",
				width : 150
			},
            {
                attributeName : "na",
                attributeHeader : "na",
                width : 150
            },
            {
                attributeName : "na",
                attributeHeader : "na",
                width : 150
            }];

		//each row will be same height within a template
		x.singleHeaderRowHeight = 18;
		x.singleBodyRowHeight = 18;
        x.singelBodyRowHeightBorder = 1; //dunno yet, need for changes in css since I use border
		x.singleFooterRowHeight = 18;

		// callbacks when setting in data, so user can change color of background etc...
		x.onCellHeaderRender = function (div, attribute) {
            //not implemented atm
        };
		x.onCellBodyRender = function (div, attribute, value, entity) {
           // console.log("onRender");
            if(attribute === "firstName" && value === "firstName12"){
                $(div).parent().css({"background-color": "rgba(255, 255, 0, 0.499219)"});
                $(div).parent().css({"color": "black"});
            } else {
                $(div).parent().css({"background-color":""});
                $(div).parent().css({"color": ""});
            }

        };
		x.onCellFooterRender = function (div, attribute) {
            //not implemented atm
        };

		//tell me how many rows there is in the template, I will need this to know height (could use jquery)
		x.templateBodyRows = 2;

		//tell me where the table is going
		x.div = "#container1";

		//datasource
		x.source = waf.sources.person;

        //tell if you want it to me a multiselect grid or single select
        x.isMultiSelect = true;


		/******************************************************************************************************************
		start creating the grid
		*******************************************************************************************************************/
		vrWidget.gridTable.create(x);


	}
	//call my params method to create grid
	
