
/******************************************************************************************************************
 Created for simulating waf dataProvider/source, so I dont have to change code when moving into wakanda.
 *******************************************************************************************************************/
var fakeDataProvider = {};

//array to hold data

fakeDataProvider.source ={};
fakeDataProvider.source.collection = [];
fakeDataProvider.selection ={};
fakeDataProvider.selection.selection = [];

var i;

//fills it with data
fakeDataProvider.fill = function (num) {
    fakeDataProvider.length = num;
    for (i = 0; i < num; i++) {
        fakeDataProvider.source.collection.push({
            ID : {value : i},
            firstName: {value : "firstName" + i},
            lastName: {value : "lastName" + i}
        });
    }
};

//simulates the dataprovider get entity in waf, so I dont haveto chnage code later

//returns the fake Data provider
fakeDataProvider.getEntityCollection = function () {
    return fakeDataProvider.source;
};

//returns selection
fakeDataProvider.getSelection = function () {
    return fakeDataProvider.selection;
};

fakeDataProvider.source.getEntity = function (i, callBack) {
    var result = {};
    result.entity = fakeDataProvider.source.collection[i];
    callBack.onSuccess(result);
};

fakeDataProvider.addListener = function (i, callBack) {
    //do nothing, just for moving easier
};

fakeDataProvider.select = function (i, callBack) {
    //do nothing, just for moving easier
};


fakeDataProvider.selection.select = function (i, add) {
    if (add === true) {
        fakeDataProvider.selection.selection.push(i);
    } else {
        fakeDataProvider.selection.selection = [i];
    }
};

fakeDataProvider.selection.selectRange = function (s, e, add) {

    var from, to, i;
    if (s > e) {
        from = e;
        to = s + 1;
    } else {
        from = s;
        to = e + 1;
    }
    if (add === true) {
        for (i = from; i < to; i++) {
            fakeDataProvider.selection.selection.push(i);
        }
    } else {
        fakeDataProvider.selection.selection = [];
        for (i = from; i < to; i++) {
            fakeDataProvider.selection.selection.push(i);
        }
    }
};


fakeDataProvider.selection.isSelected = function (s) {
    var length =  fakeDataProvider.selection.selection.length;
    var isIn = false;
    for(var i = 0;i <length;i++){
        if(fakeDataProvider.selection.selection[i]===s){
            isIn = true;
        }

    }

    return isIn;
};


fakeDataProvider.selection.setSelectedRows = function (x) {
    fakeDataProvider.selection.selection = x;

}

fakeDataProvider.selection.getSelectedRows = function () {
    return fakeDataProvider.selection.selection;

}
fakeDataProvider.selection.reset = function () {
    //nothing

}
